package question12

import (
	"os"
	"strconv"
	"testing"
)

var SIZE = 4

func TestMain(m *testing.M) {
	if len(os.Args) > 1 {
		if n, err := strconv.Atoi(os.Args[1]); err != nil {
			if len(os.Args) > 2 {
				if n, err := strconv.Atoi(os.Args[2]); err != nil {
					SIZE = 4
				} else {
					SIZE = n
				}
			} else {
				SIZE = 4
			}
		} else {
			SIZE = n
		}
	}
	os.Exit(m.Run())
}

func is_revsorted(a []int) bool {
	i := 0
	for ; i < len(a)-1 && a[i] >= a[i+1]; i++ {
	}
	return i == len(a)-1
}

func is_sorted(tab []int) bool {
	for i := 0; i < len(tab)-1; i++ {
		if tab[i] > tab[i+1] {
			return false
		}
	}
	return true
}

func less(a, b []int) bool {
	if len(a) != len(b) {
		return false
	}
	for _, v := range a {
		i := 0
		for ; i < len(b) && b[i] != v; i++ {
		}
		if i == len(b) {
			return false
		}
	}
	if is_revsorted(a) {
		return is_sorted(b)
	}
	i := 0
	for ; i < len(a) && a[i] == b[i]; i++ {
	}
	return i < len(a) && a[i] < b[i]
}

func TestFixedSmallSize(t *testing.T) {
	t.Log("Testing with a size of 3:")
	v := []int{1, 2, 3}
	save := make([]int, len(v))
	copy(save, v)
	t.Log("Original vector:", v)
	for Next_permutation(v) {
		t.Log("Next_permutation(v):", v)
		if !less(save, v) {
			t.Fatal("Next_permutation does not return a bigger permutation")
		}
		copy(save, v)

	}
	t.Log("last permutation(v):", v)
	if !less(save, v) {
		t.Fatal("Next_permutation does not return a bigger permutation")
	}

}

func nbperm(n int) int {
	r := 1
	for ; n > 0; n-- {
		r *= n
	}
	return r
}

func TestBiggerSize(t *testing.T) {
	t.Logf("Testing with a size of %v:", SIZE)
	v := make([]int, SIZE)
	for i := 0; i < SIZE; i++ {
		v[i] = i + 1
	}
	save := make([]int, len(v))
	copy(save, v)
	t.Log("Original vector:", v)
	count := 0
	for Next_permutation(v) {
		count++
		t.Log("Next_permutation(v):", v)
		if !less(save, v) {
			t.Fatal("Next_permutation does not return a bigger permutation")
		}
		copy(save, v)

	}
	count++
	t.Log("last permutation(v):", v)
	if !less(save, v) {
		t.Fatal("Next_permutation does not return a bigger permutation")
	}
	t.Log("Number of permutation:", count)
	if count < nbperm(SIZE) {
		t.Fatal("Not enough permutation generated")
	}
}
