package question13

import (
	"math/rand"
	"os"
	"strconv"
	"testing"
)

const DEFAULT_SIZE = 32

var SIZE = DEFAULT_SIZE

func TestMain(m *testing.M) {
	if len(os.Args) > 1 {
		if n, err := strconv.Atoi(os.Args[1]); err != nil {
			if len(os.Args) > 2 {
				if n, err := strconv.Atoi(os.Args[2]); err != nil {
					SIZE = DEFAULT_SIZE
				} else {
					SIZE = n
				}
			} else {
				SIZE = DEFAULT_SIZE
			}
		} else {
			SIZE = n
		}
	}
	os.Exit(m.Run())
}

func TestBasic(t *testing.T) {
	size := 5
	v := make([]int, size)
	for i := range v {
		v[i] = i
	}
	t.Log("Before reverse:", v)
	Reverse(v)
	t.Log("After reverse: ", v)
	for i := 0; i < size; i++ {
		if v[size-i-1] != i {
			t.Fatal("Reversing basic array failed")
		}
	}
}

func TestRandomFixedLen(t *testing.T) {
	v := make([]int, SIZE)
	save := make([]int, SIZE)
	for i := range v {
		v[i] = rand.Int()
	}
	copy(save, v)
	t.Log("Before reverse:", v)
	Reverse(v)
	t.Log("After reverse: ", v)
	for i := range save {
		if v[i] != save[len(save)-i-1] {
			t.Fatal("Reversing random fixed length array failed")
		}
	}
}

func TestFullRandom(t *testing.T) {
	n := rand.Intn(SIZE) + 1
	var v []int
	for i := 0; i < n; i++ {
		v = append(v, rand.Int())
	}
	save := make([]int, len(v))
	copy(save, v)
	t.Log("Before reverse:", v)
	Reverse(v)
	t.Log("After reverse: ", v)
	for i := range save {
		if v[i] != save[len(save)-i-1] {
			t.Fatal("Reversing random fixed length array failed")
		}
	}
}
