package question14

import (
	"math/rand"
	"os"
	"strconv"
	"testing"
)

const DEFAULT_SIZE = 32

var SIZE = DEFAULT_SIZE

func TestMain(m *testing.M) {
	if len(os.Args) > 1 {
		if n, err := strconv.Atoi(os.Args[1]); err != nil {
			if len(os.Args) > 2 {
				if n, err := strconv.Atoi(os.Args[2]); err != nil {
					SIZE = DEFAULT_SIZE
				} else {
					SIZE = n
				}
			} else {
				SIZE = DEFAULT_SIZE
			}
		} else {
			SIZE = n
		}
	}
	os.Exit(m.Run())
}

func TestLen0(t *testing.T) {
	l := Fibo_list(0)
	t.Logf("Fibo_list(0) = %v", l)
	if l != nil {
		t.Fatal("Fibo_list(0) must return nil")
	}
}

func TestLen1(t *testing.T) {
	l := Fibo_list(1)
	t.Logf("Fibo_list(1) = %v", l)
	if l[0] != 1 {
		t.Fatal("Fibo_list(1) must return the list [1]")
	}
}

func TestRandLen(t *testing.T) {
	n := 2 + SIZE/2 + rand.Intn(SIZE/2)
	if l := Fibo_list(n); len(l) != n {
		t.Fatalf("Fibo_list(%v) must return a list len %v", n, n)
	} else {
		if l[0] != 1 || l[1] != 1 {
			t.Fatal("Fibo_list(%v) starting values are not 1 and 1")
		}
		for i := 2; i < n; i++ {
			if l[i] != l[i-1]+l[i-2] {
				t.Fatalf("Fibo_list(%v)[%v] = %v but must be %v", n, i, l[i], l[i-1]+l[i-2])
			}
		}
		t.Logf("Fibo_list(%v) = %v\n", n, l)
	}
}
